SystemOrganization addCategory: #'LRSTM-Benchmarks'!

BenchmarkGameSuite subclass: #LRSTMBenchmarkGameSuite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Benchmarks'!

!LRSTMBenchmarkGameSuite methodsFor: 'utilities' stamp: 'StefanMarr 1/13/2013 18:32'!
adopt: obj
	Smalltalk at: #LRSTMDomain ifPresent: [:dom |
		^ dom domain adoptObject: obj].
	^ obj! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:08'!
benchAtomicBinaryTrees
	| result problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil: [ OstBGBinaryTrees defaultProblemSize ].

	[ | bench |
	  bench  := OstBGBinaryTrees new.
	  result := bench binarytrees: problemSize to: (TextStream with: String new).
	] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:08'!
benchAtomicChameleons
	| result problemSize |
	
	self error: 'This benchmark seems to be currently broken in the OmniST implementation.'.
	
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil: [ OstBGChameleons defaultProblemSize ].
	
	[ result := OstBGChameleons chameneos: problemSize ] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:08'!
benchAtomicChameneosRedux
	| result report problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil: [ OstBGChameneosRedux defaultProblemSize ].	

	[report := TextStream with: String new.
	 result := OstBGChameneosRedux new runBenchMark: problemSize on: report
	] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/5/2013 22:15'!
benchAtomicFannkuchRedux
	| result report problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil:    [ OstBGFannkuchRedux defaultProblemSize ].
	

	[report := TextStream with: String new.
	 result := OstBGFannkuchRedux fannkuchRedux: problemSize to: report
	] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/5/2013 22:16'!
benchAtomicFasta
	| out problemSize |
	problemSize := self problemSize
		ifNotNilDo: [:ps | ps ]
		ifNil:      [ OstBGFasta defaultProblemSize ].  
	
	[out := TextStream with: String new.
	 OstBGFasta fasta: problemSize to: out. ] atomic.

	^ out
! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 14:51'!
benchAtomicKNucleotide
	| bench input result problemSize output |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGKNucleotide defaultProblemSize ].
	
	[bench  := OstBGKNucleotide new.
	 input  := ReadStream on: (BGFastaCache forFasta: problemSize).
	 result := TextStream with: String new.
	 output := bench knucleotide5From: input to: result.
	] atomic.

	^ output! !

!LRSTMBenchmarkGameSuite methodsFor: 'utilities' stamp: 'StefanMarr 6/5/2013 00:25'!
benchAtomicMandelbrot
	| result bench problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGMandelbrot defaultProblemSize ].
							
	[ result := OstArray new: problemSize * problemSize / 8.
	  bench  := OstBGMandelbrot new.
	  bench mandelbrot2: problemSize to: result.
	] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'utilities' stamp: 'StefanMarr 5/6/2013 23:08'!
benchAtomicMeteor
	| problemSize result |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ OstBGMeteor defaultProblemSize ].
	
	[result := OstBGMeteor meteor: problemSize] atomic.
	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:08'!
benchAtomicNBody
	| problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil: [ OstBGNBody defaultProblemSize ].

	[ OstBGNBody nbody: problemSize ] atomic! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:10'!
benchAtomicPiDigits
	| result problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil:    [ OstBGPiDigits defaultProblemSize ].
	[ result := OstBGPiDigits piDigits: problemSize ] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 20:47'!
benchAtomicRegexDNA
	| problemSize |
	problemSize := self problemSize
		ifNotNil: [:ps | ps ]
		ifNil:    [ OstBGRegexDNA defaultProblemSize ].
	
	[OstBGRegexDNA regexdna: problemSize] atomic.! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/5/2013 00:22'!
benchAtomicReverseComplement
	| problemSize |
	problemSize := self problemSize
		ifNotNil: [:ps | ps ]
		ifNil:    [ OstBGReverseComplement defaultProblemSize ].
	
	[OstBGReverseComplement revcomp: problemSize] atomic.! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/4/2013 23:23'!
benchAtomicSpectralNorm
	| bench problemSize result |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGSpectralNorm defaultProblemSize ].

	[ bench  := OstBGSpectralNorm new.
	  result := bench spectralnorm: problemSize ] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 20:48'!
benchAtomicThreadRing
	| problemSize result |
	
	self error: 'currently not supported.'.
	
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BGThreadRing defaultProblemSize ].

	[ result := BGThreadRing threadring: problemSize ]  atomic.

	^ result! !

SMarkCompiler subclass: #LRSTMBenchCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Benchmarks'!

!LRSTMBenchCompiler methodsFor: 'benchmarking' stamp: 'StefanMarr 5/8/2013 14:04'!
benchCompiler
	[super benchCompiler] atomic! !

SMarkLoops subclass: #LRSTMBenchLoops
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Benchmarks'!

!LRSTMBenchLoops class methodsFor: 'class initialization' stamp: 'StefanMarr 9/8/2012 09:26'!
initialize
	OstObject omnifyClass: self.! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/30/2013 13:47'!
adopt: obj
	Smalltalk at: #LRSTMDomain ifPresent: [:dom |
		^ dom domain adoptObject: obj].
	^ obj! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/12/2012 13:24'!
benchArrayAccess
	| i array obj |
	
	array := OstArray new: 1.
	obj   := OstObject new.
	
	i := self problemSize.
	[i > 0] whileTrue: [
		array at: 1.
		array at: 1 put: obj.
		
		i := i - 1.
	].! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 10:42'!
benchAtomicArrayAccess
	[ self benchArrayAccess ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 10:27'!
benchAtomicClassVarBinding
	[ self benchClassVarBinding ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 12/4/2011 12:04'!
benchAtomicFloatLoop
	[ self benchFloatLoop ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 10:29'!
benchAtomicInstVarAccess
	[ self benchInstVarAccess ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 12/4/2011 12:04'!
benchAtomicIntLoop
	[ self benchIntLoop ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 10:37'!
benchAtomicSend
	[ self benchSend ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 10:38'!
benchAtomicSendWithManyArguments
	[ self benchSendWithManyArguments ] atomic.! !

!LRSTMBenchLoops methodsFor: 'initialize-release' stamp: 'StefanMarr 1/13/2013 17:45'!
initialize
	super initialize.
	self adopt: self.! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector
	<omniUnenforced>
	^ omniDomain requestExecutionOf: aSelector on: self.! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	^ omniDomain requestExecutionOf: aSelector lookup: cls on: self.! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	^ omniDomain requestExecution: p1 of: aSelector on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	^ omniDomain requestExecution: p1 with: p2 of: aSelector on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		of: aSelector
		on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		with: p4
		of: aSelector
		on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		with: p4
		with: p5
		of: aSelector 
		on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		with: p4
		with: p5
		with: p6
		of: aSelector
		on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:13'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		with: p4
		with: p5
		with: p6
		with: p7
		of: aSelector
		on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:13'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	^ omniDomain requestExecutionOf: aSelector on: self with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:13'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	^ omniDomain requestExecutionOf: aSelector on: self with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:13'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		with: p4
		with: p5
		with: p6
		with: p7
		with: p8 with: p9 with: p10
		of: aSelector
		on: self! !

OstTestCase subclass: #LRSTMBenchmarkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Benchmarks'!

!LRSTMBenchmarkTest methodsFor: 'running' stamp: 'StefanMarr 6/4/2013 15:32'!
setUp
	LRSTMTransaction TransactionClass: LRSTMTracingTransaction.
	LRSTMTracingTransaction initialize.! !

!LRSTMBenchmarkTest methodsFor: 'running' stamp: 'StefanMarr 6/4/2013 15:33'!
tearDown
	LRSTMTransaction TransactionClass: LRSTMTransaction.! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 6/5/2013 13:28'!
testAtomicBinaryTrees
	| log |
	LRSTMBenchmarkGameSuite new benchAtomicBinaryTrees.
	
	log := LRSTMTracingTransaction transactionLog.
	self assert: 1 equals: log size.
	log := log at: 1.

	self assert: 600688 equals: log numberOfChangeForRequests.
	self assert: (Dictionary newFrom: {Association -> 70. ByteArray -> 13. OstBGBinaryTrees -> 1348. OstBGTreeNode -> 598834. TextStream -> 423})
	     equals: log changedObjectClasses.! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 6/5/2013 13:28'!
testAtomicFannkuchRedux
	| log |
	LRSTMBenchmarkGameSuite new benchAtomicFannkuchRedux.
	
	log := LRSTMTracingTransaction transactionLog.
	self assert: 1 equals: log size.
	log := log at: 1.
	
	self assert: 999 equals: log numberOfChangeForRequests.
	self assert: (Dictionary newFrom: {Association -> 14. ByteArray -> 1. OstArray -> 574. OstBGFannkuchRedux -> 2. OstBGPermGeneratorRedux -> 357. OstInterval -> 23. TextStream -> 28})
	     equals: log changedObjectClasses.! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 6/5/2013 13:27'!
testAtomicFasta
	| log |
	LRSTMBenchmarkGameSuite new benchAtomicFasta.
	
	log := LRSTMTracingTransaction transactionLog.
	self assert: 1 equals: log size.
	log := log at: 1.
	
	self assert: 306995 equals: log numberOfChangeForRequests.
	self assert: (Dictionary newFrom: {Association -> 50375. OstArray -> 33599. OstBGFasta -> 20209. OstBGRandomNumber -> 32006. OstBGRandomStream -> 81494. OstBGRepeatStream -> 18020. TextStream -> 71292})
	     equals: log changedObjectClasses.! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 6/5/2013 13:27'!
testAtomicKNucleotide
	| log |
	LRSTMBenchmarkGameSuite new benchAtomicKNucleotide.
	
	log := LRSTMTracingTransaction transactionLog.
	self assert: 1 equals: log size.
	log := log at: 1.
	
	self assert: 1015724 equals: log numberOfChangeForRequests.
	self assert: (Dictionary newFrom: {Array -> 210697. Association -> 294388. ByteArray -> 85. ByteString -> 1. Fraction -> 180. OstArray -> 221. OstAssociation -> 166027. OstBGKNucleotide -> 13. OstDictionary -> 338569. OstSortedCollection -> 426. ReadStream -> 2742. ReadWriteStream -> 560. TextStream -> 787. WriteStream -> 1028})
	     equals: log changedObjectClasses.! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 6/5/2013 11:34'!
testAtomicNBody
	| log changes |
	LRSTMBenchmarkGameSuite new benchAtomicNBody.
	
	log := LRSTMTracingTransaction transactionLog.
	self assert: 1 equals: log size.
	log := log at: 1.
	
	self assert: 401750 equals: log numberOfChangeForRequests.
	self assert: (Dictionary newFrom: {Association -> 5. OstArray -> 25097. OstBGBody -> 245298. OstBGNBody -> 27076. OstOrderedCollection -> 104274})
	     equals: log changedObjectClasses.! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 6/5/2013 11:27'!
testAtomicPiDigits
	| log |
	LRSTMBenchmarkGameSuite new benchAtomicPiDigits.
	
	log := LRSTMTracingTransaction transactionLog.
	self assert: 1 equals: log size.
	log := log at: 1.
	
	self assert: 1829 equals: log numberOfChangeForRequests.
	self assert: (Dictionary newFrom: {Association -> 3. OstArray -> 27. OstBGPiDigitSpigot -> 1795. OstBGPiDigits -> 4})
	     equals: log changedObjectClasses.! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 6/5/2013 13:25'!
testAtomicReverseComplement
	| log |
	LRSTMBenchmarkGameSuite new benchAtomicReverseComplement.
	
	log := LRSTMTracingTransaction transactionLog.
	self assert: 1 equals: log size.
	log := log at: 1.
	
	self assert: 250926 equals: log numberOfChangeForRequests.
	self assert: (Dictionary newFrom: {Association -> 21350. OstArray -> 6. OstAssociation -> 12. OstBGReverseComplement -> 6. RWBinaryOrTextStream -> 84228. ReadWriteStream -> 1140. TextStream -> 71272. WriteStream -> 72912})
	     equals: log changedObjectClasses.! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 6/5/2013 00:53'!
testAtomicSpectralNorm
	| log |
	LRSTMBenchmarkGameSuite new benchAtomicSpectralNorm.
	
	log := LRSTMTracingTransaction transactionLog.
	self assert: 1 equals: log size.
	log := log at: 1.
	
	self assert: 404643 equals: log numberOfChangeForRequests.
	self assert: (Dictionary newFrom: {Association -> 2. OstArray -> 404599. OstBGSpectralNorm -> 42})
	     equals: log changedObjectClasses.! !

Object subclass: #LRSTMBenchmark
	instanceVariableNames: ''
	classVariableNames: 'Value'
	poolDictionaries: ''
	category: 'LRSTM-Benchmarks'!

LRSTMBenchmark class
	instanceVariableNames: 'value mutex doneCount'!

LRSTMBenchmark class
	instanceVariableNames: 'value mutex doneCount'!

!LRSTMBenchmark class methodsFor: 'utilities' stamp: 'lr 5/30/2007 16:10'!
benchmark: aOriginalBlock reference: aReferenceBlock label: aString
	"Assert that aFastBlock is executed faster than aSlow block. The two blocks should be relatively fast and have no side effects, as they are executed multiple times."
	
	| originalTime referenceTime |
	originalTime := aOriginalBlock timeToRun.
	referenceTime := aReferenceBlock timeToRun.
	Transcript 
		show: aString; tab;
		show: ((referenceTime / 1000.0) roundTo: 0.01); tab;
		show: ((originalTime / 1000.0) roundTo: 0.01); tab;
		show: ((originalTime / referenceTime) asFloat roundTo: 0.01); cr! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:16'!
benchmarkActivation
	"self benchmarkActivation"
	
	self 
		benchmark: [ 10000000 timesRepeat: [ [ ] atomic ] ]
		reference: [ 10000000 timesRepeat: [ [ ] value ] ]
		label: 'Activation'! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:17'!
benchmarkBinding
	"self benchmarkBinding"

	self
		benchmark: [ [ 10000000 timesRepeat: [ Value ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ Value ] ] value ]
		label: 'Binding Read'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ Value := nil ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ Value := nil ] ] value ]
		label: 'Binding Write'.! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:17'!
benchmarkInstance
	"self benchmarkInstance"
	
	self 
		benchmark: [ [ 10000000 timesRepeat: [ value ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ value ] ] value ]
		label: 'Instance Read'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ value := nil ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ value := nil ] ] value ]
		label: 'Instance Write'! !

!LRSTMBenchmark class methodsFor: 'btree' stamp: 'StefanMarr 1/4/2012 15:39'!
benchmarkParallel
	"self benchmarkParallel"

	| semaphore data doneCnt repeatCount time btreeCls |
	semaphore := Semaphore forMutualExclusion.
	btreeCls := Smalltalk at: #BTree.
	
	1 to: 70 do: [ :processCount |
		Smalltalk garbageCollect.
		
		data := btreeCls new.
		doneCnt := 0.
		repeatCount := 500.
	
		processCount timesRepeat: [
			[ repeatCount timesRepeat: [ self twoAtomicUpdates: data ].
			  semaphore critical: [ doneCnt := doneCnt + 1 ] ]
				forkAt: Processor activeProcess priority ].
		time := [
			[ doneCnt < processCount ]
				whileTrue: [ Processor yield ] ]
			timeToRun.

		Transcript show: processCount; tab; show: time; cr ]! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:17'!
benchmarkSend
	"self benchmarkSend"
	
	self
		benchmark: [ [ 10000000 timesRepeat: [ nil flag: #zork ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ nil flag: #zork ] ] value ]
		label: 'Message invokation'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ nil flag: #zork ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ 1 + 2 ] ] value ]
		label: 'Message invokation (fast)'! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:18'!
benchmarkVariable
	"self benchmarkVariable"

	self 
		benchmark: [ [ 10000000 timesRepeat: [ #( nil ) at: 1 ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ #( nil ) at: 1 ] ] value ]
		label: 'Variable Read'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ #( nil ) at: 1 put: nil ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ #( nil ) at: 1 put: nil ] ] value ]
		label: 'Variable Write'! !

!LRSTMBenchmark class methodsFor: 'btree' stamp: 'lr 5/31/2007 17:11'!
twoAtomicUpdates: aDictionary
	[ [ aDictionary 
		at: SmallInteger maxVal atRandom put: 0;
		at: SmallInteger maxVal atRandom put: 0 ]
			atomic ]
		on: LRSTMConflict
		do: [ self twoAtomicUpdates: aDictionary ]! !

!LRSTMBenchmark class methodsFor: 'btree' stamp: 'lr 6/1/2007 11:01'!
twoMutexUpdates: aDictionary
	mutex critical: [
		aDictionary
			at: SmallInteger maxVal atRandom put: 0;
			at: SmallInteger maxVal atRandom put: 0 ]! !
LRSTMBenchLoops initialize!
